package vm

import (
	"context"
	"github.com/jinzhu/copier"
	"github.com/pkg/errors"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/helper/xerr"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/repository/result"
	"gitlink.org.cn/JointCloud/pcm-coordinator/pkg/utils"
	"gitlink.org.cn/JointCloud/pcm-openstack/openstack"
	"k8s.io/apimachinery/pkg/util/json"

	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/svc"
	"gitlink.org.cn/JointCloud/pcm-coordinator/internal/types"

	"github.com/zeromicro/go-zero/core/logx"
)

type DeleteNetworkSegmentRangesLogic struct {
	logx.Logger
	ctx    context.Context
	svcCtx *svc.ServiceContext
}

func NewDeleteNetworkSegmentRangesLogic(ctx context.Context, svcCtx *svc.ServiceContext) *DeleteNetworkSegmentRangesLogic {
	return &DeleteNetworkSegmentRangesLogic{
		Logger: logx.WithContext(ctx),
		ctx:    ctx,
		svcCtx: svcCtx,
	}
}

func (l *DeleteNetworkSegmentRangesLogic) DeleteNetworkSegmentRanges(req *types.DeleteNetworkSegmentRangesReq) (resp *types.DeleteNetworkSegmentRangesResp, err error) {
	// todo: add your logic here and delete this line
	DeleteNetworkSegmentRangesReq := &openstack.DeleteNetworkSegmentRangesReq{}
	err = copier.CopyWithOption(DeleteNetworkSegmentRangesReq, req, copier.Option{Converters: utils.Converters})
	DeleteNetworkSegmentRangesResp, err := l.svcCtx.OpenstackRpc.DeleteNetworkSegmentRanges(l.ctx, DeleteNetworkSegmentRangesReq)
	if err != nil {
		return nil, errors.Wrapf(xerr.NewErrMsg("c端创建失败"), "c端创建失败 : %v ,req:%+v", err, req)
	}
	marshal, err := json.Marshal(&DeleteNetworkSegmentRangesResp)
	if err != nil {
		return nil, result.NewDefaultError(err.Error())
	}
	json.Unmarshal(marshal, &resp)
	err = copier.CopyWithOption(&resp, &DeleteNetworkSegmentRangesResp, copier.Option{Converters: utils.Converters})
	return resp, err
}
